#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_RobNoticeCFG.h"
std::auto_ptr<M_RobNoticeCFG> M_RobNoticeCFG::msSingleton(nullptr);

int M_RobNoticeCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_RobNoticeCFGData* M_RobNoticeCFG::GetData(std::string ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<std::string, M_RobNoticeCFGData>& M_RobNoticeCFG::GetMapData()
{
	return mMapData;
}

void M_RobNoticeCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_RobNoticeCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_RobNoticeCFGData data;
		data.mID = element->Attribute("ID");
		data.mShowPos = element->IntAttribute("ShowPos");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_RobNoticeCFG Loaded. Load Data:%u", mMapData.size());
}

void M_RobNoticeCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_RobNoticeCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_RobNoticeCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_RobNoticeCFGData data;
		LuaCfgHelper::readString(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "ShowPos", data.mShowPos);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_RobNoticeCFG Loaded. Load Data:%u", mMapData.size());
}

void M_RobNoticeCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_RobNoticeCFG* M_RobNoticeCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_RobNoticeCFG());
	}
	return msSingleton.get();
}

void M_RobNoticeCFG::Release()
{
	msSingleton.reset(nullptr);
}
